#!/bin/bash
#PBS -l mem=16gb
#PBS -l walltime=1d
#PBS -l nodes=1:ppn=2

cd /storage/brno9-ceitec/home/fialaji8/speechdat_ml

. ./path.sh
. ./cmd.sh

languages="PL HU RU CS SK"

for lang in $languages;do
    # Filter features
    echo "Filtering features $lang"
    [ -d fmllr_feats_$lang ] && rm -r fmllr_feats_$lang
    mkdir -p fmllr_feats_$lang/dev
    mkdir -p fmllr_feats_$lang/test

    for s in test dev; do
        cat fmllr_feats/$s/feats.scp | grep $lang > fmllr_feats_$lang/$s/feats.scp
        cat fmllr_feats/$s/spk2gender | grep $lang > fmllr_feats_$lang/$s/spk2gender
        cat fmllr_feats/$s/spk2utt | grep $lang > fmllr_feats_$lang/$s/spk2utt
        cat fmllr_feats/$s/text | grep $lang > fmllr_feats_$lang/$s/text
        cat fmllr_feats/$s/utt2spk | grep $lang > fmllr_feats_$lang/$s/utt2spk
        cat fmllr_feats/$s/wav.scp | grep $lang > fmllr_feats_$lang/$s/wav.scp
    done

    graph_dir=exp/ml/tri3/graph_lm_${lang}_ML

    echo "Decoding $lang"
    for st in test dev; do 
        steps/nnet/decode.sh --use_gpu no \
		                     --num_threads 1 \
	   	                     --nj 10 \
		                     --cmd "$decode_cmd" \
		                     --config conf/decode_dnn.config \
		                     --acwt 0.1 \
		                     $graph_dir    \
		                     fmllr_feats_$lang/$st \
 		                     exp/ml/dnn5b_pretrain-dbn_dnn/DECODE_${st}_$lang \
                             > log/DECODE_TEST_${lang}.log
    done
done



