#!/bin/bash
# Copyright (c) 2013, Ondrej Platek, Ufal MFF UK <oplatek@ufal.mff.cuni.cz>
# modified by Jiri Fiala, FEE CVUT
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
# THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
# WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
# MERCHANTABLITY OR NON-INFRINGEMENT.
# See the Apache 2 License for the specific language governing permissions and
# limitations under the License. #
test_text=$1; shift
dir=$1; shift

[ -d $dir ] && rm $dir/*
! [ -d $dir ] && mkdir $dir

echo "Preparing the LM ..."

function build_0gram {
    echo "Building zerogram $lm ..."
    transcr=$1; lm=$2
    cut -d' ' -f2- $transcr | tr ' ' '\n' | sort -u > $lm
    echo "<s>" >> $lm
    echo "</s>" >> $lm
    python -c """
import math
with open('$lm', 'r+') as f:
    lines = f.readlines()
    p = math.log10(1/float(len(lines)));
    lines = ['%f\\t%s'%(p,l) for l in lines]
    f.seek(0); f.write('\\n\\\\data\\\\\\nngram  1=       %d\\n\\n\\\\1-grams:\\n' % len(lines))
    f.write(''.join(lines) + '\\\\end\\\\')
"""
}

lm_order=0
echo "Building LM of order ${lm_order}..."
if [ $lm_order -eq 0 ] ; then
    grep 'S[0-9]\|Z[0-9]' $test_text  | cut -d' ' -f2-| awk NF  | sed -e 's:^:<s> :' -e 's:$: </s>:' | \
        sort -u > $dir/lm_test.txt
    build_0gram  $dir/lm_test.txt $dir/lm_tg
    gzip $dir/lm_tg
fi
echo "LM preparation finished."


